<template>
  <displacement-card
    :id="shuttle.id"
    :day="day"
    :hour="hour"
    :month="month"
    :departure="passenger.departure.label"
    :arrival="passenger.arrival.label"
    :cancelable="cancelable"
    @delete-displacement="emitDelete"
  >
    <template #title>
      <h2>Navette sur {{ shuttle.campus.name }}</h2>
    </template>
    <template #default>
      <ul>
        <li v-if="translatedStatus">
          Statut :  <em>{{ translatedStatus }}</em>
        </li>
      </ul>
    </template>
  </displacement-card>
</template>

<script>
import { CANCELED_STATUSES } from '@fabnumdef/e-chauffeur_lib-vue/api/status';
import displacementCard from '~/components/cards/displacement.vue';
import displacementCardMixin from '~/components/cards/mixins/displacement-cards';

export default {
  components: {
    displacementCard,
  },
  mixins: [displacementCardMixin('shuttle')],
  props: {
    shuttle: {
      type: Object,
      required: true,
    },
    cancelable: {
      type: Boolean,
      default: false,
    },
  },
  computed: {
    passenger() {
      return this.shuttle.passengers.find(({ id }) => id === this.$auth.user.id);
    },
    translatedStatus() {
      if (CANCELED_STATUSES.includes(this.shuttle.status)) {
        return this.translateStatus(this.shuttle.status);
      }
      if (this.passenger) {
        return this.translateStatus(this.passenger.status);
      }

      return '';
    },
  },
  methods: {
    emitDelete(id) {
      this.$emit('delete-shuttle', id, 'shuttle');
    },
  },
};
</script>
